<?php

class Crawler extends Module
{
    function __construct()
    {
    }

	function read()
	{
		$result = array('ret'=>0,'info'=>'','data'=>'');
        $profile = $this->getParam('profile');
		$file = BASE_PATH.'/model/'.$profile.'.php';
		if( is_file( $file ) )
		{
			require_once $file;
		}
		else
		{
			$result['ret'] = -1;
			$result['info'] = 'can\'t find '.$file;
			echo json_encode( $result );
			return;
		}

		$result['data'] = $query;
		echo json_encode( $result ); 
	}

	function deal()
	{
		global $query, $result;
		$fields= array('title','titlefilter','content','contentfilter','maxpage','charset','url','multi');
		$query = $this->getFields( $fields );

		$result['query']= json_encode( $query );
		$obj = CrawlTool::getInstance();
		//$obj->getModel( $query['profile'] );
		$data = $obj->deal();
		//var_dump($result);exit;
		$result['data'] = print_r($data, true);
		echo json_encode($result);
	}
    

	function export()
	{
		$fields= array('profile','title','titlefilter','content','contentfilter','maxpage','charset','url','multi');
		$query = $this->getFields( $fields );

		$str = <<<eof
<?php 
\$filter = array('script', 'style');
\$query = array(
	'contentfilter'=>\$filter,
	'titlefilter'=>\$filter,
_fields_
); 
eof;

		$oFields = '';
		foreach( $query as $key => $value )
		{
			if( is_array( $value ) )
			{
				$oFields .= "    '{$key}'=>array(";
				foreach( $value as $kv => $vv )
				{
					$oFields .= "'{$kv}'=>'{$vv}',";
				}
				$oFields .= "),\n";
			}
			else
			{
				$oFields .= "    '{$key}'=>'{$value}',\n";
			}
		}

		$str = str_replace( '_fields_', $oFields, $str);
		file_put_contents( BASE_PATH.'/model/'.$query['profile'].'.php', $str ); 
	}


	function getFields( $fields )
	{
		$query = array();
		foreach( $fields as $field )
		{
			$value = $this->getParam($field);
			$value = trim($value);
			if( $value )
			{
				$query[$field] = $this->getParam($field);
				if( strpos( $field, 'filter') !== false )
				{
					$query[$field] = explode(',', $query[$field]);
				}
			}	
		} 
		return $query;
	}

    function downLoad()
    {
        // http://localhost/img/3.jpg
        $url = $this->getParam('url');
        if( ! $url )
        {
            throw new Exception(__FUNCTION__.": can't find parameter url.");
        }
        
        $file = $this->getParam('file', 'tmp.jpg');
		$file = BASE_PATH.'/img/'.basename($file);
        $this->info( array( 'url' => $url, 'file' => $file ) );
        $ret = array();
        
        try
        {
            $order = "wget {$url} -O {$file} > /tmp/info.txt";
            system( $order );
			sleep(1);
			$info = file_get_contents('/tmp/info.txt');
			$this->info( array($order, "exec result =[{$info}]") );

            if( is_file( $file ) )
            {
                $retinfo = 'scceess.';
                $ret['img'] = 'http://localhost/img/'
                        . basename( $file );
            }
            else
            {
                $retinfo = 'failed.';
            }
            $this->info( "download file : url=[{$url}]" );
            $this->info( $retinfo );
            $ret['info'] = $retinfo;
            echo json_encode( $ret );
        }
        catch(Exception $e)
        {
            $ret = 'exception.';
            echo json_encode( $ret );
        }
    }
    
    function display()
    {
        parent::display('crawler');
    }
}
